--- u-boot/common/cmd_ide.c	2005-12-29 12:14:50.000000000 -0600
+++ u-boot-hwrev-1.0/common/cmd_ide.c	2005-12-29 15:10:55.000000000 -0600
@@ -1227,7 +1227,7 @@ ulong ide_read (int device, lbaint_t blk
 #ifdef CONFIG_LBA48
 	unsigned char lba48 = 0;
 
-	if (blknr & 0x0000fffff0000000) {
+	if (blknr & (lbaint_t)0x0000fffff0000000LL) {
 		/* more than 28 bits used, use 48bit mode */
 		lba48 = 1;
 	}
@@ -1281,8 +1281,13 @@ ulong ide_read (int device, lbaint_t blk
 			/* write high bits */
 			ide_outb (device, ATA_SECT_CNT, 0);
 			ide_outb (device, ATA_LBA_LOW,	(blknr >> 24) & 0xFF);
+#ifdef CFG_64BIT_LBA			
 			ide_outb (device, ATA_LBA_MID,	(blknr >> 32) & 0xFF);
 			ide_outb (device, ATA_LBA_HIGH, (blknr >> 40) & 0xFF);
+#else			
+			ide_outb (device, ATA_LBA_MID,	0);
+			ide_outb (device, ATA_LBA_HIGH, 0);
+#endif			
 		}
 #endif
 		ide_outb (device, ATA_SECT_CNT, 1);
@@ -1346,7 +1351,7 @@ ulong ide_write (int device, lbaint_t bl
 #ifdef CONFIG_LBA48
 	unsigned char lba48 = 0;
 
-	if (blknr & 0x0000fffff0000000) {
+	if (blknr & (lbaint_t)0x0000fffff0000000LL) {
 		/* more than 28 bits used, use 48bit mode */
 		lba48 = 1;
 	}
@@ -1371,8 +1376,13 @@ ulong ide_write (int device, lbaint_t bl
 			/* write high bits */
 			ide_outb (device, ATA_SECT_CNT, 0);
 			ide_outb (device, ATA_LBA_LOW,	(blknr >> 24) & 0xFF);
+#ifdef CFG_64BIT_LBA			
 			ide_outb (device, ATA_LBA_MID,	(blknr >> 32) & 0xFF);
 			ide_outb (device, ATA_LBA_HIGH, (blknr >> 40) & 0xFF);
+#else			
+			ide_outb (device, ATA_LBA_MID,	0);
+			ide_outb (device, ATA_LBA_HIGH, 0);
+#endif			
 		}
 #endif
 		ide_outb (device, ATA_SECT_CNT, 1);
